//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************
#define AN 0xFF
#define AUS 0x00

#include <webpage.h>
static char countaccess=0;

int httpd (char* buffer,int *bufferlen)
{	
	//Einlesen des TCP Socket
	unsigned int	TCP_Socket = (buffer[TCP_srcport]<<8) + buffer[TCP_srcport+1];
	
	for (int a=0;a<10;a++)
		{
		//berprft HTTP Header 
		if ((buffer[TCP_hdrflags+1]&PSH_Flag) > 0 && TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 1)
			{
			unsigned int result16 = ((buffer[ip_vers_len] & 0x0F) << 2) + ((buffer[TCP_hdrflags] & 0xF0) >>2) + 14;
			pointerold = Page1;
			for (int a = result16;a < (result16 +20);a++)
			{
			if (buffer[a] == 'a' 		// Drucker an
				&& buffer[a + 1] == 'n')
				{
					pointerold = Page2;
					PORTB = AN;
					countaccess++;
				}	
			if (buffer[a] == 'a' 		// Drucker aus
				&& buffer[a + 1] == 'u' 
				&& buffer[a + 2] == 's')
				{
					pointerold = Page2;
					if (--countaccess < 1)
					{
						countaccess = 0;
						PORTB = AUS;
						pointerold = Page3;
					}
				}	
			}
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);		
			//Setzen des Ack Flag
			buffer[TCP_hdrflags+1] |= ACK_Flag;
			//erzeugt HTTP OK Packet
			tcp_add_data (HTTP_OK1,buffer,bufferlen);	
			//Erzeugt ein TCP Packet 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP Packet 
			Write_Ethernet_Frame (buffer,*bufferlen);
			TCP_Socket_Status[a] = 2;
			TCP_Socket_Pointer[a] = pointerold;
			return(0);
			}
		}
		
	for (int a=0;a<10;a++)
		{
		if (TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 2)
			{
				buffer[TCP_hdrflags+1] |= PSH_Flag;
				//Speichert Sequenzcounter und Aknowledgecounter
				tcp_store(buffer);		
				//erzeugt Seiten Packet
				pointerold = TCP_Socket_Pointer[a];
				tcp_add_data (pointerold,buffer,bufferlen);
				TCP_Socket_Pointer[a] = pointerold;
				//Erzeugt ein TCP Packet 
				tcp_make(buffer);			
				//Sendet das erzeugte TCP Packet 
				Write_Ethernet_Frame (buffer,*bufferlen);	
				if (Sendpage == 0)
					{
					TCP_Socket_Status[a] = 3;
					}
				return (0);		
			}
		}

	for (int a=0;a<10;a++)
		{
		if (TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 3)
			{
			TCP_Socket_Store[a] = 0;
			TCP_Socket_Status[a] = 0;
//			printf("\nTCP Socket Close %d\n",TCP_Socket);
			TCP_PORT_CLOSE (buffer,bufferlen);
			break;
			}
		if (TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 0)
			{
//			printf("TCP Socket Open %d\n",TCP_Socket);
			TCP_Socket_Status[a] = 1;
			break;
			}	
		}
return (0);
}


